#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "dim_sdk.h"

PLUG_INFO("Example plugin", "0.0.1", "GPLv3")

typedef struct plug_t {
    char* some_data;
    int count;
} plug_t;

plug_t* p = {0};

void plug_init() {
    p = malloc(sizeof(plug_t));
    assert(p != NULL && "Buy more ram KEKW");
    p->count = 0;

    printf("Hello from plugin");
}

void* plug_pre_reload() {
    return p;
}

void plug_post_reload(void *state) {
    p = state;
}

void plug_poll(char *buf, size_t len) {
    snprintf(buf, len, "Hello from C! (%d)", p->count++);
}

void plug_free() {
    free(p);
}
